package com.er.test64ANE
{
	import flash.external.ExtensionContext;
	import flash.system.Capabilities;
	
	public class ane64Lib
	{
		private static var _instance:ane64Lib;	
		private var extCtx:ExtensionContext;
		
		public static function getInstance():ane64Lib
		{
			return _instance != null ? _instance : new ane64Lib();
		}
		
		public function ane64Lib()
		{
			if (!_instance)
			{
				if (this.isSupported)
				{
					extCtx = ExtensionContext.createExtensionContext("com.er.ur.test64extension", null);
					
					if (extCtx == null)
					{
						throw Error('Error creating ane64Lib');
					}
				}
				_instance = this;
			}
			else
			{
				throw Error('instance of ane64Lib already exists.');
			}
		}
		
		public function get isSupported():Boolean
		{
			return Capabilities.manufacturer.indexOf('Macintosh') > -1;
		}
		
		public function getNumber():int
		{
			if (extCtx == null)
			{
				throw Error('No Extension Context');
			}
			else
			{
				return extCtx.call("getNumber") as int;
			}
		}
	}
}